    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.operation;
    022
    023import cascading.tuple.Fields;
    024import cascading.tuple.TupleEntry;
    025import cascading.tuple.TupleEntryCollector;
    026
    027/** Interface FunctionCall provides access to the current {@link Function} invocation arguments. */
    028public interface FunctionCall<C> extends OperationCall<C>
    029  {
    030  /**
    031   * Returns {@link TupleEntry} of argument values.
    032   * <p/>
    033   * Note that the returned TupleEntry should not be cached (stored in a Collection), nor should the underlying Tuple
    034   * instance. Where possible Cascading will re-use both TupleEntry and Tuple instances.
    035   * <p/>
    036   * To get a safe copy that can be cached, use {@link TupleEntry#getTupleCopy()}.
    037   *
    038   * @return TupleEntry
    039   */
    040  TupleEntry getArguments();
    041
    042  /**
    043   * Return the resolved {@link Fields} declared by the current {@link Operation}.
    044   *
    045   * @return Fields
    046   */
    047  Fields getDeclaredFields();
    048
    049  /**
    050   * Returns the {@link cascading.tuple.TupleEntryCollector} used to emit result values.
    051   *
    052   * @return TupleCollector
    053   */
    054  TupleEntryCollector getOutputCollector();
    055  }